Source Code Control Reference

The Microsoft development environment (for Visual J++™ and Visual InterDev™) integrates source control commands and functions into the Project Explorer (and other menus and windows). You can use source control to manipulate source item locations and versions, set up your source control project hierarchy to match your development directory tree, and more effectively manage team projects by delaying additions, deletions, and renames to the source control database.

The following sections provide more information on using source code control integrated with the Microsoft development environment.

Section | Description
Source Code Control Concepts | Introduces concepts key to understanding source control integration provided by the Microsoft development environment.
Source Code Control Common Tasks | Provides step-by-step instructions for performing common source control tasks.
Source Code Control User Interface Reference | Provides a user interface reference to the dialog boxes you will see as you use source control through the Microsoft development environment.
Source Code Control Error Messages | Provides links to topics explaining error messages you may encounter, along with workarounds.


Source Code Control Concepts

The Microsoft development environment (for Visual J++™ and Visual InterDev™) integrates source control commands and functions into the Project Explorer (and other menus and windows). You can use source control to manipulate source file (item) locations and versions, set up your source control project hierarchy to match your development directory tree, and more effectively manage team projects by delaying additions, deletions, and renames to the source control database.

Note The examples in this section refer to Microsoft® Visual SourceSafe™ as the default source code control application. If you are using Visual InterDev for source code control, please see the Visual InterDev topics Source Control or Working with Multiple Developers. If you are using another source code control system, please see your source code control provider for more information.

The following sections provide information to acquaint you with source code control in the Microsoft development environment.

Section | Description
What is Source Code Control? | Gives a brief overview of using the features of source control and the development environment together.
Setting Up Source Code Control with the Microsoft Development Environment | Briefly describes the first steps to integrating the Microsoft development environment with your Visual SourceSafe database.
Different Project Models in Source Code Control | Compares directory-based and reference-based project systems, describing how the differences impact source code control.
Overview of Pushing or Pulling Changes to Source Code Control | Introduces a means to selectively defer updates to local or database files.


What Is Source Code Control?

With source control systems, you use a database to track, organize, and manage "projects." These projects are a unit of organization, like a folder, and can contain various kinds of files (items), including code and documentation. This version control enables you to more flexibly manage the contents of projects (for example, to include only items labeled as a "release" version of the application) and manage project history (to restore an older version, for example, for testing or rerelease). Some features are available only in the Microsoft development environment; some features are specific to Visual SourceSafe only. This section describes what you can do with each feature set and what you can do using them together.

With Visual SourceSafe and the Microsoft development environment, you can:

  • Control all the projects and solutions in one central database for your team to access.

  • Use the basic source control commands directly in the Project Explorer (in the development environment).

  • View the history of a source control project.

  • Share the same item among many source control projects (without making copies of it everywhere).

  • Branch an item to create a unique copy of another item (in Visual SourceSafe).

  • Merge two versions of the same item together (in Visual SourceSafe).

Controlling All the Projects and Solutions in One Central Database

A typical source code control configuration assumes that all the files are kept in one master source code control database on a server, linked to the developers' computers by a network link. The master database is where you store the original information, such as code and documentation, and the individual computers are where you edit and compile the files. With a central location of the files for your team, you can better control the access to the files and the organization of the project tree.

Using the Source Control Commands in the Project Explorer

The Microsoft development environment integrates the basic commands and functions of Visual SourceSafe directly into the Project Explorer for ease of use. The development environment also tracks the status of the projects and solutions to aid with renaming, adding, and deleting files to Visual SourceSafe.

You can maintain the files and code in the master source control database through these four basic commands, available in the Project Explorer (in the development environment):

  • Get Latest Version

    The Get Latest Version command retrieves the most current copy of the item from the master source control server and copies it to the local machine. The item is still read-only. For step-by-step instructions, see Getting the Current Version of an Item.

  • Add to Source Control

    You can Add to Source Control the project or solution shown in the Project Explorer (in the development environment). This sends a copy of the files to the master source control database you specify in the Visual SourceSafe project tree. For step-by-step instructions, see Adding a Project or Solution to Source Control.

  • Check Out

    The Check Out command retrieves the latest version of the item from the master source code control database and reserves that item to the local user who is checking it out. For step-by-step instructions, see Checking Items In and Out.

    In Visual SourceSafe, you can set the check out option to exclusive (one person at a time) or multiple (check out one item to many people at once). The default setting is exclusive check out. This avoids many editing conflicts when checking the item back in.

  • Check In

    The Check In command copies a local item to the master database, adding the latest version. For step-by-step instructions, see Checking Items In and Out.

Viewing the History of a Project

You can see the history of a source control project through the History command in the development environment. This tells you when the latest changes were made, and by whom, and what happened to the item each time it was checked in, from the time it was first created. For step-by-step instructions, see Viewing the History of a Source Control Item.

Sharing Files

You can share an item across more than one source control project (Visual SourceSafe only). When you update one copy of the shared file, all copies reflect the new changes. The shared item is stored only once in the Visual SourceSafe database, with pointers to the item in the other projects. For step-by-step instructions, see Sharing a Project.

This method makes it possible to share common components across several different projects. Keep in mind that source control systems can store any kind of item — including code, documentation, stored procedures, and HTML items.

Branching Shared Files

Branching is feature specific to Visual SourceSafe. You can branch a project in source control by sharing a project to an additional location in your source control project tree. When the project is shared, you can choose to branch the project, and the connection to the duplicate project is broken, so that changes are no longer updated from the other shared projects.

You can use the Change Location command in the development environment to point your local project to the new location of the project in source control. This feature is useful for creating a special version of a common file, for creating separate versions for language differences, or for customizing an application. You can also use this feature to branch files of a specific version of the finished application.

Merging Versions Together

You can put two versions of the same item together with the merge feature (available only in Visual SourceSafe). This feature displays the two versions of the items side by side in Visual SourceSafe, and you reconcile the changes you want to keep in the final version of the item.

Merging versions is useful if the multiple check out feature in Visual SourceSafe is enabled. This is also useful when updating changes to a branched item.


Setting Up Source Control with the Microsoft Development Environment

Once you set up Microsoft® Visual SourceSafe™, you can perform several steps to integrate it with the Microsoft development environment. With this integration, you can use the environment to track item versioning, renaming, deleting, and more. First steps to integrating the development environment with your Visual SourceSafe database include:

  • Installing the server or client Visual SourceSafe applications to set up your master source code control database.

  • Finding or connecting with the Visual SourceSafe database.

  • Mirroring your development directory tree in Visual SourceSafe's project structure for ease of use.

  • Adding projects or solutions to the master source control database.

Choosing the Client or Server Installation of Visual SourceSafe

When you first install Visual SourceSafe, you have two options:

  • Server Installation

  • Client Installation

The server installation is performed once by the administrator of your network. This creates the server's source code control database, to be used by all of your team. The administrator can then add users with the administrator application. (The administrator also needs to install the client application of Visual SourceSafe to the server to use Visual SourceSafe.)

The client installation is for all the local machines that are going to access the master source code control database. The database server itself also needs to include the client installation if the administrator wishes to run Visual SourceSafe and access the files on that machine. The client application works with the development environment to give you access and control over your source control files.

The administrator can setup Visual SourceSafe to provide a way for local users to install the client application over the network from the server's location. This process, called netsetup, provides the database location information to the client application.

When you install Visual SourceSafe, select the "IDE Integration Option" to incorporate the Microsoft development environment. For more information on installing Visual SourceSafe, see the Visual SourceSafe documentation.

Finding or Connecting with the Visual SourceSafe Database Server

You may want to reestablish a connection with the source code control database because you:

  • Need to find the initial connection to the source control database.

  • Have lost the network connection to the source code control server.

  • Want to change the Visual SourceSafe project in which you're working (or your Visual SourceSafe project was moved or renamed).

  • Must work offline on a separate computer or laptop (assuming you already have an established connection with the source control database).

If you need to find the initial connection to your source control database, see Changing/Setting a Connection to the Source Control Database for more information and step-by-step instructions.

In the next two cases, if you need to reconnect to the source code control database, you can use the Change Location command on the development environment Project menu (in the Source Control submenu) to change the connection.

If the name of your database project changes, you can use the Change Location command to link your local copy of source code control with the current source control server.

If you must work offline, you can Check Out the items you want (or Get the latest versions) and then go offline. This feature disables any further messages about a lost connection with the source control server. When you reconnect, you can change this to online and Check In your files.

Mirroring Your Development Directory Tree in Visual SourceSafe's Project Structure

A typical source code control network assumes that all the files are kept in one master source code control database on a server, linked to the developers' computers by a network link. The master database is where you store the original information, such as code and documentation, and the individual computers are where you edit and compile the files.

Your hard drive is organized into a directory tree, usually with a root directory labeled c:\ and folders or subdirectories such as c:\res\icons. The Visual SourceSafe database is organized in a very similar manner — in a project tree. The project root is labeled $/ and it can contain subprojects such as $/Resources/Icons. Visual SourceSafe projects and subprojects are organized similar to the directories or folders on your machine's hard drive.

When you work on a project in Visual SourceSafe, you associate a local directory path name, or Working Folder, with that project (this is known as the "working directory" for the project). This local directory path name, such as D:\projects\proj1\res\icons, can mirror the structure of the Visual SourceSafe project, $/Project1/Resources/Icons. This path name can be customized for each user and loosely correlates with the Visual SourceSafe project. Another developer can set up their own machine to access the same Visual SourceSafe project with a local directory path of C:\projects\proj1\graphics, and point to $/Project1/Resources/Icons.

If you are just starting out with Visual SourceSafe, a good strategy is to map the project layout in the source code control database to mirror the names and hierarchy of the usual development directory tree. This makes the associations recognizable. You can add shared files and branching later. The development environment will populate the directory tree from the solution when you first check in the solution.

Adding Projects or Solutions to the Source Control Database

You can add projects or solutions through the development environment with the Add to Source Control command. When you add a solution to source code control, all the projects in that solution can be added as well. This is useful when you have a large number of projects to add to source control at once.

The first time you open a project in source control, you use the New Project command (on the File menu) and click Source Control to get to the database. Afterward, the development environment remembers the location of the database for you.

When you first join a team that is working on a source control project, you need to get current copies of all the source control files used by your team. To retrieve copies of the files from the database to your local machine, Open the project and click Source Control. You can use the Get command to retrieve the latest copies of the files to your local machine.

Visual SourceSafe supports a "branch" (forking) function, where you create a new version of a project. This command cannot be performed from within the development environment (only within Visual SourceSafe). However, if you do branch a project, the development environment's last known location for the project will not match the new location. To resolve this, you should use the Change Connection command to modify the source control connection for the projects in the solution, and check that in immediately. Other people can then use Open Project (Source Control menu) to open the new project.


Different Project Models in Source Code Control

When working in the Microsoft development environment, you are using one of two kinds of projects: reference-based or directory-based. These distinctions are not presented as categories within the environment, but they influence how your projects will be treated in source control tasks.

The reference-based project is similar to a Microsoft® Visual Basic® or Visual C++® project, in that it uses a project file to list and track files contained in the project, source code control information on those files, and other data. These project files may be physically located anywhere on the developer's system. Examples of a reference-based project (in the development environment) include Utility Projects or Database Projects.

The directory-based project is similar to a Visual J++™ project, in that it uses the directory that holds the project to define the list of files to build for that project. The directory-based project contains a project file but does not use that file as its only method of defining the list of files and their respective locations. All files in a directory-based project must be in the project's root directory or a subdirectory of the project's root directory.

The following table lists and compares characteristics of these two project models:

Reference-based projects | Directory-based projects
You use the project file as the current list of files to build. This is also how a reference-based project tracks dependency files for builds. | You use the actual presence of the files in the specified directory as the current list of files in a project (along with maintaining a file list in the project file).
You track source code control issues in the project file. | You track source code control issues by altering directory contents.
Only files you choose in your settings for your build configuration are included in builds. | You can choose files to drop out of the build in the Project Explorer by removing them from the project. This will not delete the files but make them appear a lighter gray in the display.
You can build multiple projects that reference a single item in one location. | You must keep a separate copy of an item in a different directory for each project in which it builds.
You can keep files in the directory that are not part of the project. | You only include files that are completed and built in the directory. The files in progress are kept locally.
You can have placeholder or incomplete (or not built) files in the directory. | All files in the project directory will be built. Use the Exclude feature in the Project Explorer to ensure that the project contains only files that can be built.
A project can span subdirectories. You can use this to sort file types, possibly storing core files in one directory, user interface files in another, and so on. The project's files may be anywhere on the developer's system. | Each project is completely contained within its directory or a subdirectory of the project's root directory.
Multiple projects can be located in the same directory. | One project is contained in a given directory.
Only files referred to in the project file will be synchronized with source code control. | Files contained in the project directory are included in the next build after you synchronize with source code control.
When moving files, file paths must be updated in the project file. | No absolute path names in the project file, so the project can be moved as an entire unit, by moving the entire directory.


Overview of Pushing or Pulling Changes to Source Code Control

Source control systems typically allow you to work on a project locally without affecting the work of other team members. However, some operations (such as add, delete, and rename) traditionally have required you to synchronize your local work immediately with other team members, or to remember to synchronize at the same time as you check in.

With the development environment and Visual SourceSafe together, you can:

  • Control when changes you make to an item are checked into the master source control database.

  • Develop strategies for delaying changes to or from source control.

You can delay changes locally until the all files are changed and/or working together. As you use source code control, the Microsoft development environment can remind you of incomplete actions or delay changes to your local solution.

Controlling When Your Changes Affect the Source Control Project

You can delay three basic source control actions (adding, renaming, and removing). These actions can be delayed for indeterminate amounts of time. Source control actions can go two ways — from the server to the local machine or to the server from the local machine.

You can delay these changes by clicking Remind on certain dialog boxes. Later you are prompted about the item, and you can send it on or delay it again. This can continue indefinitely, but the longer you delay a change to source control, the higher the probability for merge changes or other problems.

The initial dialog boxes that delay or remind you on these changes to source control appear according to certain actions, called pushing or pulling. Pushing an item refers to sending a copy of the changed item to the source control server from the local machine. Pulling an item refers to retrieving a copy of the changed item from the source control server to the local machine. The dialog boxes appear when an item is on one location for example, (your local machine) and not the other for example, (the source control server).

The dialog boxes that remind you of the delayed actions occur, by default, whenever a project item is pushed or pulled. Pushing actions include Check In and Add to Source Control. Pulling actions include Get Latest, Check Out, and Undo Check Out. You can change the timing of these reminder dialog boxes to appear all the time or not at all. For step-by-step instructions on how to set the timing of the reminders, see Changing the Timing of Reminder Dialog Boxes.

Strategies for Delaying Files to Source Control

You can delay adding a file, deleting a file, or renaming a file. This keeps your changes in the source control database from affecting your local files until you are ready. Depending on whether you are working with reference- or directory-based projects, you should employ a strategy that makes the most of the project model.

One strategy for directory-based projects is to check in the item initially, when it is created, so the name of the item is reserved in source control. You can then hold the item checked out locally while you work on it until you think that the item is ready to build. Before building, you can check in the item with the new version of the item ready to build available to the team.

For reference-based projects, the buildable state of the files in the source control database is not as critical, since the builds specify which files are to be used, instead of pulling all the files from a directory by default. The delaying tactics here become a good idea for testing and initial work in roughing out the content in the file.

CAUTION Delaying changes to source code control for too long — especially if the source control database has other incomplete rename or delete actions with the same item — can lead to complicated situations and an unknown state of your file. Don't forget that source code control is intended to hold different versions of the item in a central location so you can restore a prior version if necessary.


Source Code Control Common Tasks

This section contains step-by-step instructions for the most common Microsoft development environment tasks related to source control. You can also rename a file and delay a change to your local machine or the source control database, using the source control features available in the development environment.

Note You cannot delay source control actions while working with Microsoft® Visual InterDev™. If you are using Visual InterDev and Microsoft® Visual SourceSafe™, please read the instructions for using source control in Working with Multiple Developers.

These tasks include:

Adding a Project or Solution to Source Control

Changing the Reminder Dialog Box Timing

Changing/Setting a Connection to the Source Control Database

Checking Items In and Out

Enabling the Source Control Dialog Boxes to Appear

Getting the Current Version of an Item

Removing Projects or Solutions

Renaming Items

Sharing an Item

Viewing the History of a Source Control Item


Adding a Project or Solution to Source Control

Usually when you add a solution to source control, you want to add the entire solution. If your solution is located on more than one directory, and you select that solution and add it to source control, you are prompted with the Initial Solution Add dialog box. You can choose to add a single solution file (.sln) or only the selected items in the Project Explorer.

You can add individual projects or items to source control when you want detailed control over the versions of those projects or items.

To add a solution to source control

  1. In the Project Explorer, select the solution.

  2. On the Project menu, point to Source Control, and then click Add to Source Control.

  3. In the Initial Solution Add dialog box, choose if you would like to add just the selected items in the Project Explorer, or the entire solution.
    • Click Selection to add just the solution file (.sln file) to source control.

    • Click Solution to add the solution file, the projects, and all their items to source control.
  4. In the Add to SourceSafe Project dialog box (or the equivalent dialog box provided by your source control program), choose where you want your project to be placed in source control.
    • In the Add to SourceSafe dialog box, click Create. Enter the new source control folder name. Click OK.

    • Select an existing source control folder in which to place your items if you are certain that the existing source control folder's directory structure and files will not conflict with the new item and any corresponding directory structure of the new item.
  5. In the Add to Source Control dialog box, select the items you want to add to source control, and then click OK.

    You can add comments and select Keep Checked Out.

To open a project from source control through the development environment

  1. On the File menu, click Open Project.

  2. In the Open Project dialog box, click Source Control.

  3. In the Create Local Project From SourceSafe dialog box, click the SourceSafe project to "download" or open the folder.

    As you make your selections in the SourceSafe project listing, the default folder location for your selection is listed in the Create a new project in the folder list box. Look at that entry to make sure it is correct.

  4. Click OK.

    You now have a local copy of the project. You only need to open the solution file from the local machine to access this project.

To automatically add new projects to source control as you create them

  1. On the Tools menu, click Options.

  2. In the Options dialog box, expand the Environment node and click the Source Control node.

  3. Select the Add new projects to source control check box.

  4. Click OK.


Changing Reminder Dialog Box Timing

As you use source code control, the Microsoft development environment can display reminder dialog boxes to remind you of incomplete actions or delayed changes to the master copy of the solution and its contents.

Note Reminders and delaying actions do not apply to Web projects created in Visual InterDev. For more information, please refer to the Visual InterDev topic in Working with Multiple Developers.

Reminder dialog boxes prompt you to perform an action, delay an action until later, or skip the action entirely. You can change the default settings to control when reminder dialog boxes are displayed. By default, when a project is pushed or pulled, a reminder will appear, if needed.

When you push changes, you send them to the source control server from the local machine. Pushing actions include Check In and Add to Source Control. These dialog boxes prompt you to synchronize the source control server and the local machine so that the same version of the items exists in both places.

When you pull changes you retrieve them from the source control server to the local machine. Pulling actions include Get Latest, Check Out, and Undo Check Out. These dialog boxes prompt you to synchronize the source control server and the local machine so that the same version of the items exists in both places.

To change the timing of the pull reminder dialog boxes in the development environment

You can enable the pull dialog boxes by changing the options listed in the Source Control page.

  1. On the Tools menu, click Options.

  2. In the Options dialog box, expand the Environment node, and then click the Source Control node.

  3. In the Show pull reminders list, select one of the following:
    • Select On every pull to show the reminder dialog boxes every time you perform a pull action (Get Latest, Check Out, or Undo Check Out) on any item in the Project Explorer.

    • Select On project pull to show the reminder dialog boxes when you perform a pull action (Get Latest, Check Out, or Undo Check Out) only on a project or solution in the Project Explorer. This is the default setting.

    • Select Never to disable the pull reminder dialog boxes.
  4. Click OK.

To change the timing of the push reminder dialog boxes in the development environment

You can enable the dialog boxes by changing the options listed in the Source Control page.

  1. On the Tools menu, click Options.

  2. In the Options dialog box, expand the Environment node, and then click the Source Control node.

  3. In the Show push reminders list, select one of the following:
    • Select On every push to show the reminder dialog boxes every time you perform a push action (Check In or Add to Source Control) on any item in the Project Explorer.

    • Select On project push to show the reminder dialog boxes when you perform a push action (Check In or Add to Source Control) only on a project or solution in the Project Explorer. This is the default setting.

    • Select Never to disable the push reminder dialog boxes.
  4. Click OK.


Changing/Setting a Connection to the Source Control Database

In the course of working with source control, you might at some time lose your connection to your source control server, or lose a connection to your source control project on the server due to a branching source control action.

When you are working offline, you are not connected to the source control database/server. This can be intentional (as when you are working remotely on a laptop) or accidental (as when a network connection breaks).

You may need to reestablish a connection with your source control project if a project is moved in the source control database. In this case, you must redirect the development environment to the new location, so that the development environment can update the status of files in those projects or the solution.

To reconnect to the source control server through the development environment

  1. On the Project menu, point to Source Control, and then click Change/Set Connection.

  2. In the Change/Set Connection dialog box, click Work Online, and then click Connection.

    The source control program displays a dialog box that connects you to a source control server or project. Find your project and click OK.

When you branch a project in Visual SourceSafe, you need to redirect the development environment to point to the new location of the project in the source control database.

Warning You can usually safely use the Share command in Visual SourceSafe to share files. However, solution and project files (.sln, .vjp, etc.) should never be shared, but always branched.

To reconnect to a source control project through the development environment after a branching operation

  1. In the Project Explorer, select the project.

  2. If you wish to reconnect the whole of the solution to a single place where it was previously connected, select any item, and then select the Apply changes to other projects with similar connections check box.

  3. On the Project menu, point to Source Control, and then click Set Connection.

  4. In the Set Connection dialog box, click Work Online, and then click Connection.

    The source control program displays a dialog box that connects you to a source control server or, if you are still connected with your source control server, the projects in source control.

  5. In the dialog box provided by your source control program, choose the source control project. If you have branched all projects at once, you may wish to select the Apply changes to other projects with similar connections check box.

  6. Click OK.


Checking Items In and Out

When you check an item in to the source control server, the source control system changes the status of the file from read/write to read-only, and updates the copy of the file in the database to synchronize it with the local copy.

After you check an item into source control, that item is available for other people to work on. If you want to return an item to source control without any changes, you can undo the check out.

Checking out an item copies the version of the item from the source control server to your local machine and makes it read/write on the local machine. This action also locks the item on the source control server, by making it read-only (unless your source control is configured to do multiple checkouts).

It is possible to check in items through either the Microsoft development environment or your source control program. By performing all your major source control operations through the development environment, however, you ensure that the development environment updates projects and solutions correctly.

To check out a solution, project, or item from source control through the development environment

  1. In the Project Explorer, select the item that you want to check in to source control. The selection must already have been added to source control to be available to check out.

  2. On the Project menu, point to Source Control, and then click Check Out.

    If the check out command is visible but grey, this means the item is checked out by someone else. If the item is invisible, this means that checking out this item is an inappropriate action at this time.

  3. In the Check Out Items dialog box, verify that the items you want to check out are selected, and then click OK.

To check in a solution, project, or item to source control through the development environment

  1. In the Project Explorer, select the solution, project, or item that you want to check in to source control. To check in an item, you must have checked the item out from source control.

  2. On the Project menu, point to Source Control, and then click Check In.

  3. In the Check In Items dialog box, select the items you want to check in, and then click OK.

To automatically check in all items when closing the solution

  1. On the Tools menu, click Options.

  2. In the Options dialog box, expand the Environment node, and then click the Source Control node.

  3. Select the Check in everything when closing the solution check box.

  4. Click OK.

To undo a check out

  1. In the Project Explorer, select the item that was checked out.

  2. On the Project menu, point to Source Control. Click Undo Check Out.

  3. In the Undo Check Out dialog box, select the items you wish to return to their previous state.

  4. Click OK.

    Undoing the checkout erases any changes you made to that item and returns it to the state it was in before it was checked out.


Enabling the Source Control Dialog Boxes to Appear

The Microsoft development environment provides two basic types of dialog boxes to assist you in source control tasks. You use the first type, detail dialog boxes, to perform basic source control tasks (for example, Check In, Get Latest Version). You use the second type, push or pull dialog boxes, to act upon delayed pushes or pulls to the source control server (for example, Push Add to Server or Reminder to Push Remove to Server).

You can disable the detail dialog boxes by selecting the "Don't show this dialog box again" check box on each. You can enable the dialog box to appear again using the options on the Source Control (Environment – Tools Dialog Box).

For details on changing the timing and appearances of the push or pull dialog boxes, including the reminder dialog boxes, see the step-by-step instructions on Changing the Timing of Reminder Dialog Boxes.

To enable the detail dialog boxes for source control in the development environment

  1. On the Tools menu, click Options.

  2. In the Options dialog box, expand the Environment node, and then click the Source Control node.

  3. In the Source Control (Environment – Tools) dialog box, in the Detail Dialogs section, select the detail dialog box that you want to enable.

    All checked dialog boxes will appear when you choose the corresponding command from the Project menu, Source Control submenu. You can adjust the settings for the following dialog boxes:

    • Check Out

    • Check In

    • Undo Check Out

    • Add to Source Control

    • Get Latest Version
  4. Click OK.


Getting the Current Version of an Item

Updating your local copies of items to versions from the master source control database is called "getting" or "synchronizing" items. In any project with more than one team member working on an item, you should update your local copies frequently to ensure that you incorporate changes that other people have made.

When you Get your local items, the master versions of the items are copied to your local project. You have not checked out the items, and you cannot modify them and check in changes, but you can view them or use them in builds of your project.

Note If the file is "pinned" in Visual SourceSafe, the pinned version is the version retrieved. For more information on pinning, see the Visual SourceSafe documentation.

To get the latest version of an item in source control through the development environment

  1. In the Project Explorer, select the items that you want to Get.

  2. On the Project menu, point to Source Control, and then click Get Latest Version.

    The Get Latest Version dialog box appears, with check marks next to the items in the Items box. If necessary, adjust selections in this dialog box.

  3. Click OK.

To automatically get current versions of items when opening a solution

  1. On the Tools menu, click Options.

  2. In the Options dialog box, expand the Environment node, and then click the Source Control node.

  3. Select the Get everything when opening the solution check box.

Note This does not apply to Visual InterDev projects.

  4. Click OK.


Removing Projects or Solutions

When you remove items from your solution, you may first want to remove them from source control. You can remove items from source control — for example, the solution file (.sln) — but you cannot remove the entire solution. This is also true for projects. You can remove the particular project file (for example, a Java project file is .vjp) or a Cabinet packaging project file (.pkp) but not the entire Java or Cabinet project.

Individual items in Web projects created in Visual InterDev cannot be removed from source control. You can select Disconnect Web Project to remove all your items at one time. See your Visual InterDev documentation for more details.

For more details on how to remove source control projects in the source control database, see your source control provider's documentation.

To remove individual items from source control through the development environment

  1. In the Project Explorer, select the item that you want to remove from source control.

  2. On the Project menu, point to Source Control, and then click Remove From Source Control.

  3. In the Remove Items From Source Control dialog box, adjust selections if necessary. Selected items are shown with a check mark.

  4. Click OK.


Renaming Items

You can request new names for items in the Microsoft development environment. These requests are passed to your source control server to see if they are legal names, not identical to other names, and that they pass all the regulations set by that source control program. If the new name is accepted by your source control program, and then the name is changed.

To rename an item in source control through the development environment

  1. If the item you want to rename is checked in, check out the item from source control.

  2. In the Project Explorer, select the item.

  3. On the File menu, click Rename.

  4. In the Project Explorer, edit the item name.

  5. In the Push Rename to Server dialog box, select the items to control with the action of your choice. You can push the selected rename items to the source control server, be reminded later about the items, or do nothing and keep the rename local to your machine.

  6. Click OK.

If something is wrong somewhere and the source control database project needs the correct name, and there is no other way to rename the items involved through the development environment, you can rename the item only in the source control database (through the development environment). This is not the procedure to rename an item in your local project — use the File menu, Rename command for that. Any changes made with this Rename dialog box are not reflected on your local machine, just on the source control database, which may introduce discrepancies later.

To rename an item in the source control database only

  1. In the Project Explorer, select the item, project, or solution.

  2. On the Project menu, point to Source Control, and then click Rename.

  3. In the Rename File in Source Control dialog box, enter the new name for the item in the New item name box.

    This name request is for the source control database only, and will not be reflected in the Microsoft development environment.

  4. Click Rename.


Sharing an Item

You can share an item across source control projects when Visual SourceSafe is your source control provider. When you update one copy of the shared file, all copies reflect the new changes. The shared item is stored only once in the Visual SourceSafe database, with pointers to the item in the other projects. Do not share project or solution files.

Note The ability to share items is not available in Visual InterDev.

To share an item in the development environment

  1. In the Project Explorer, select either the folder or project in which you want to place the shared files.

  2. On the Project menu, point to Source Control, and then click Share.

  3. In the Visual SourceSafe Share dialog box, browse in the directory list for the item you want to share and click that item.

  4. Click Share.

Note Whenever possible, you should perform source control action — for example, Check Out — through the development environment so that the environment can keep an accurate understanding of the actions performed on that item.


Viewing the History of a Source Control Item

A source control program keeps a record of all the versions of the items that you added to source control. You can check the history records on these items with some source control systems. In the Microsoft development environment, you can check the history of a source control item without leaving the development environment.

With Visual SourceSafe, the history of an item includes: the version, the user, the date, and the action. For more information on the History feature of Visual SourceSafe, see the Visual SourceSafe documentation.

Note Viewing the history of an item is not available in Visual InterDev.

To view the history of a source control item in the development environment

  1. In the Project Explorer, select the item.

  2. On the Project menu, point to Source Control, and then click History.

    Your source control program displays the history of the item.

  3. In Visual SourceSafe, the History Options dialog box appears. Pick any options and then click OK.

    Visual SourceSafe displays the history for the selected item in the History dialog box.


Source Code Control User Interface Reference

The Microsoft development environment integrates source control systems (such as Microsoft® Visual SourceSafe™) into the Project Explorer and other menus and windows. The following dialog boxes assist you in performing source control tasks.

Add Conflicts with Deferred Delete Dialog Box

Add Conflicts with Deferred Rename Dialog Box

Add to Source Code Control Dialog Box

Check In Items Dialog Box

Check Out for Editing Dialog Box

Check Out for Save Dialog Box

Check Out Items Dialog Box

Conflicting Modifications Detected Dialog Box

Defer Source Control Operation Dialog Box

Get Latest Version Dialog Box

Incomplete Deletion Conflicts with Added Item Dialog Box

Incomplete Rename of Added Item Dialog Box (I)

Incomplete Rename of Added Item Dialog Box (II)

Pull Added Items from Server Dialog Box

Pull Removed Items from Server Dialog Box

Push Add to Server Dialog Box

Push Remove to Server Dialog Box

Push Remove to Server (Incomplete Rename) Dialog Box

Push Rename to Server Dialog Box

Reminder to Push Add to Server Dialog Box

Reminder to Push Remove to Server Dialog Box

Reminder to Push Rename to Server Dialog Box

Remove Items From Source Control Dialog Box

Rename Item in Source Control Dialog Box

Set Source Control Connection Dialog Box

Source Control (Environment - Options Dialog Box)

Specify Working Directory Dialog Box

Undo Check Out Dialog Box


Add Conflicts With Deferred Delete Dialog Box

Use this dialog box to resolve a delayed action that is interfering with your adding items to the source control server. The items you deleted locally were not deleted on the source control server (the deleting action was delayed). These deleted items match names with the items you are trying to add now.

Options

Items

Displays a list of the items that are in conflict with your current action, adding an item to source control. The items listed were deleted locally, but not deleted on the source control server. The names of these locally deleted items match the names of the items you are trying to add to the source control server.

Push Delete

Deletes from the source control server the items listed in the Items box. Afterward, you will be prompted to continue with your original action to add items.

Allow Conflict

Proceeds with the source control action, which may overwrite or change the items listed in the Items box. This action ignores any delayed actions that were not pushed to the server. Also, since you are ignoring this delayed action, the development environment will no longer keep a record of it. Next, you will continue with adding items to source control.


Add Conflicts With Deferred Rename Dialog Box

Use this dialog box to resolve a situation that is interfering with adding items to source control. The items you renamed locally were not renamed on the source control server (the renaming action was deferred). These renamed items have the same names as the items you are trying to add now.

Options

Items

Displays a list of the items that are in conflict with your current action. These items were renamed locally, but not renamed on the source control server. The source control database names for these items match the names of the items you are trying to add to the source control server.

Push Rename

Renames the source control server items to match the list in the Items box. Afterward, you will be prompted to continue with your original action to add items.

Allow Conflict

Proceeds with the source control action, which may overwrite or change the items on the source control server. These items are listed by their local names in the Items box. This action ignores any delayed actions that were not pushed to the server. Also, since you are ignoring this delayed action, the development environment will no longer keep a record of it.


Add Files to Source Code Control Dialog Box

Add to Source Code Control Dialog Box

Use this dialog box to add solutions, projects, or individual items to source control. Items marked with a check mark in the Items box are added to the source control server.

Options

Items

Displays a list of the items based on your current selection in the Project Explorer (in the development environment). Select the box next to the items you wish to add to source control and a check mark will appear next to the item. You can click Check All to select all of the items at once.

This box displays the first level of folders and contents to which you can apply these operations. To see additional items contained within subfolders, click Recurse. Items contained within a subfolder are not added to source control unless they are displayed individually in the Items box and selected with a check mark.

Recurse

Forces items to be displayed in subfolders in the Items box. You can then select these items for source control actions.

By default, the Items box displays only the first level of items contained in the Project Explorer for the development environment. Clicking Recurse displays all of the subfolders and all of their items for any remaining levels in the directory tree. You can then select additional items for actions in source control.

Keep Checked Out

Refreshes the source control server with the latest version of the local items that are selected, but keeps the items checked out to you.

Comment

Provides a place to enter comments. If your source control program is Microsoft® Visual SourceSafe™, you can type up to 4,095 characters.

Check All

Selects with a check mark all of the items visible in the Items box. To see additional subfolders and levels of items, click Recurse. Only items that are visible in the Items box and are shown with a check mark are added to source control.

Advanced

Displays more options on adding to source control. Your source control program supplies these options.


Check In Items Dialog Box

Use this dialog box to check in solutions, projects, or individual items from your local machine to the source control server. Items marked with a check mark in the Items box are checked in to the source control server.

Checking in an item copies the current version of the local item you're working on to the source control server. This action also unlocks the item on the source control server, so that the item is available to check out by other people.

Options

Items

Displays a list of the items based on your current selection in the Project Explorer (in the development environment). Select the box next to the items you wish to check in to source control and a check mark will appear next to the item. You can click Check All to select all of the items at once.

This box displays the first level of folders and contents to which you can apply these operations. To see additional items contained within subfolders, click Recurse. Items contained within a subfolder are not checked in to source control unless they are displayed individually in the Items box and selected with a check mark.

Recurse

Forces items to be displayed in subfolders in the Items box. You can then select these items for source control actions.

By default, the Items box displays only the first level of items contained in the Project Explorer for the development environment. Clicking Recurse displays all of the subfolders and all of their items for any remaining levels of depth in the directory tree, as shown in the Project Explorer. You can then select additional items for actions in source control.

Keep Checked Out

Refreshes the source control server with the latest version of the local items that are selected, but keeps the items checked out to you.

Don't show any more check in dialogs

Suppresses any more instances of the Check In to Source Control dialog box. Check In to Source Control becomes a direct command on the environment menus. You will not be able to add comments or use advanced options until you enable this dialog box again.

You can enable this dialog box again by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).

Comment

Provides a place to enter comments. If your source control program is Microsoft® Visual SourceSafe™, you can type up to 4,095 characters.

Check All

Selects with a check mark all of the items visible in the Items box. To see additional subfolders and levels of items, click Recurse. Only items that are visible in the Items box and are shown with a check mark are checked in to source control.

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.

Differences

Displays a comparison of the selected item version with previous versions of the item. Your source control program supplies these comparisons.


Check Out For Editing Dialog Box

Use this dialog box to set the behavior of the development environment when you start editing an item that you did not check out first. When you click OK, items marked with a check mark in the Items box are checked out from the source control server in this instance.

Options

Items

Displays a list of the items that are in conflict with your current action. Click the box next to the items you wish to check out from source control and a check mark will appear next to the item. You can click Check All to select all of the items at once.

Don't show any more check out for edit dialogs

Suppresses any more instances of the Check Out For Editing dialog box. If you suppress the dialog box, when you are editing an item that is not checked out, the development environment beeps and checks the item out for you (without prompting).

You can enable this dialog box again by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).

  • Always Check Out — Choose this if you would like the development environment to always check out the item from source control. This means that if you edit items in the development environment, you will not be prompted, and the environment will beep and check out the item. You may also lose a keystroke while this action is performed. The editor or window you are in may change to accommodate the change in item status.

  • Always Do Nothing — Choose this if you would like the default behavior of the development environment to leave the item local and not check it out from source control. This means that as you edit items in the development environment, you will not be prompted to check out an item. If the editor allows you to edit the local item, it will contain different information than the copy in the source control database (which you may have to manually merge together later).

Comment

Provides a place to enter comments. If your source control program is Microsoft® Visual SourceSafe™, you can type up to 4,095 characters.

Check All

Selects with a check mark all of the items visible in the Items box. To see additional subfolders and levels of items, click Recurse. Only items that are visible in the Items box and are shown with a check mark are checked out from source control.

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Check Out for Save Dialog Box

Use this dialog box to preserve the changes you made to the item and perform any simultaneous source control action. Otherwise, you might be prompted about the item you are editing being read-only and not checked out from source control.

You can save these changes in the source control copy of the item by checking that item out from source control with this dialog box. Items marked with a check mark in the Items box are checked out from the source control server and the changes saved to that item.

If you do not want to save your changes to this item, do not check the item out from source control.

Options

Items

Displays a list of the items that are not checked out of source control. Select the check box next to the items you wish to check out from source control and a check mark will appear next to the item.

Comment

Provides a place to enter comments. If your source control program is Microsoft® Visual SourceSafe™, you can type up to 4,095 characters.

Check Out

Checks out the items selected in the Items box. Your changes to these items are preserved if you save this item and check the item back into source control.

Save As

Saves the item you are currently modifying with a different name.

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Check Out Items Dialog Box

Use this dialog box to check out solutions, projects, or individual items from source control. Items marked with a check mark in the Items box are checked out from the source control server.

Checking out an item copies the current version of the item from the source control server to your local machine. This action also locks the item on the source control server, so that the item is read-only (unless your source control is configured to do multiple checkouts).

Options

Items

Displays a list of the items based on your current selection in the Project Explorer (in the development environment). Select the box next to the items you wish to check out from source control and a check mark will appear next to the item. You can click Check All to select all of the items at once.

This box displays the first level of folders and contents to which you can apply these operations. To see additional items contained within subfolders, click Recurse. Items contained within a subfolder are not checked out from source control unless they are displayed individually in the Items box and selected with a check mark.

Recurse

Forces items to be displayed in subfolders in the Items box. You can then select these items for source control actions.

By default, the Items box displays only the first level of items contained in the Project Explorer for the development environment. Clicking Recurse displays all of the subfolders and all of their items for any remaining levels of depth in the directory tree, as shown in the Project Explorer. You can then select additional items for actions in source control.

Don't show any more check out dialogs

Suppresses any more instances of the Check Out Items dialog box. Check Out From Source Control becomes a direct command on the environment menus. You will not be able to add comments or use advanced options until you enable this dialog box again.

You can enable this dialog box again by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).

Comment

Provides a place to enter comments. If your source control program is Microsoft® Visual SourceSafe™, you can type up to 4,095 characters.

Check All

Selects with a check mark all of the items visible in the Items box. To see additional subfolders and levels of items, click Recurse. Only items that are visible in the Items box and are shown with a check mark are checked out from source control.

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Conflicting Modifications Detected Dialog Box

Use this dialog box to finish a File Save action. While trying to save the item, the development environment found two copies of the item with the same name but differing contents. You can specify what resolution to take or click Cancel to temporarily postpone the resolution. If you cancel, you can investigate the situation. You will be prompted to resolve this situation again if you cancel now.

Options

Save As

Saves with a different name the item you are currently modifying. This item is then labeled differently from the other item the development environment found (same name, different content).

Overwrite

Proceeds with the save action, which may overwrite or change the items listed in the Items box on your local machine. This finishes the File Save action.

Cancel

Cancels the entire File Save action and this dialog box so that you can examine the items in question.


Defer Source Control Operation Dialog Box

Use this dialog box to delay a source control pull action (Check Out, Undo Check Out, or Sync). While trying to perform this action, the development environment found the items listed to be in danger of possible overwriting with the server copies because the development environment cannot reload the items at this time. You should delay the source control action until you are done working on this solution and close it.

Options

Items

Displays a list of the items that are in conflict with your current action. Copies from the source control server may overwrite these items unless you delay this source control action.

Defer

Delays the pull action (Check Out, Undo Check Out, or Sync) until you close the current solution. The development environment completes the source control pull action automatically when the solution is closed. When you open the solution again, the items will be synchronized and your changes will be merged with those changes made by other users.

Skip

Skips over the items listed in the Items box for this source control action. Only the items listed in this Items box are skipped, not all of the possible items in the source control "pull" action (this action can be Check Out, Undo Check Out, or Sync).

Pull Action Now

Performs the source control pull action (Check Out, Undo Check Out, or Sync) now, possibly overwriting those items listed in the Items box with copies from the source control server.

Cancel

Aborts the entire source control "pull" action (Check Out, Undo Check Out, or Sync).


Get Latest Version Dialog Box

Use this dialog box to retrieve a read-only copy of solutions, projects, or individual items from source control. Items marked with a check mark in the Items box are copied from the source control server.

Get Latest Version places a copy of the requested item or items in the local copy of the solution.

Options

Items

Displays a list of the items based on your current selection in the Project Explorer (in the development environment). Select the box next to the items you wish to get from source control and a check mark will appear next to the item. You can click Check All to select all of the items at once.

This box displays the first level of folders and contents to which you can apply these operations. To see additional items contained within subfolders, click Recurse. Items contained within a subfolder are not retrieved from source control unless they are displayed individually in the Items box and selected with a check mark.

Recurse

Forces items to be displayed in subfolders in the Items box. You can then select these items for source control actions.

By default, the Items box displays only the first level of items contained in the Project Explorer for the development environment. Clicking Recurse displays all of the subfolders and all of their items for any remaining levels of depth in the directory tree, as shown in the Project Explorer. You can then select additional items for actions in source control.

Directories

Shows all of the directories of all of the items in your current selection. You can use the Recurse box to show additional directories.

Don't show any more Get dialogs

Suppresses any more instances of the Get Latest Version dialog box. Get Latest Version becomes a direct command on the environment menus. You will not be able to add comments or use advanced options until you enable this dialog box again.

Get items from subdirectories

Shows all of the items in the directories that you selected (checked) when Directories is selected. You can use this with Directories to Get items that are directly nested in your project but not visible in the Project Explorer. This is useful for exposing new subfolders in a directory-based project.

Check All

Selects with a check mark all of the items visible in the Items box. To see additional subfolders and levels of items, click Recurse. Only items that are visible in the Items box and are shown with a check mark are retrieved from source control.

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Incomplete Deletion Conflicts with Added Item Dialog Box

Use this dialog box to resolve a situation that is interfering with your adding items to the local project or solution. The items you deleted locally were not deleted on the source control server (the deleting action was deferred). These deleted items match names with the items you are trying to add locally now.

Options

Items

Displays a list of the items that are in conflict with your current action. These items were deleted locally, but not deleted on the source control server. The names of these locally deleted items match the names of the items you are trying to add to the local project or solution.

Push Delete

Deletes from the source control server the items listed in the Items box. Afterward, you will be prompted to continue with your original action to add items locally.

Skip Add

Cancels these selected items to Add to Source Control and ignores the outstanding delete items. The development environment will no longer keep a record of the deleted items (that were not deleted on the source control server).


Incomplete Rename of Added Item Dialog Box (I)

Use this dialog box to resolve a situation that is interfering with your adding items to the source control server. The items you renamed locally were not renamed on the source control server (the renaming action was deferred). These deferred items (using the outdated names) match the names of the items you are trying to add now.

Options

Items

Displays a list of the items that are in conflict with your current action. These items were renamed locally, but not renamed on the source control server. The outdated names of these items match the names of the items you are trying to add to the source control server.

Push Rename

Renames the list in the Items box on the source control server to match the local names. Afterward, you will be prompted to continue with your original action to add items.

Skip Add

Cancels these selected items to Add to Source Control and ignores the outstanding delete items. The development environment will no longer keep a record of the items that were only renamed locally. The source control server will not reflect the new names.


Incomplete Rename of Added Item Dialog Box (II)

Use this dialog box to resolve a situation that is interfering with your adding items to the source control server. The items you renamed locally were not renamed on the source control server (the renaming action was deferred). The outdated names of these items match the names of the items you are trying to add now.

Options

Items

Displays a list of the items that are in conflict with your current action. These items were renamed locally, but not renamed on the source control server. The outdated names of these items match the names of the items you are trying to add to the source control server.

Push Rename

Renames items in the Items box on the source control server to match the local names. Afterward, you will be prompted to continue with your original action to add items.

Skip Add

Cancels the Add to Source Control action for the items listed and ignores the outstanding renamed items. Only the items listed in the Items box are skipped, not all of the possible items in your original Add to Source Control action.

Add Anyway

Proceeds with the Add to Source Control action, which may overwrite or change the items listed in the Items box. This action ignores any delayed actions that were not pushed to the server. Also, since you are ignoring this delayed action, the development environment will no longer keep a record of it.


Initial Solution Add Dialog Box

Use this dialog box to specify the scope of the files to add to source control. You can add the entire solution, consisting of the solution file, all project files, and all files contained in the projects. You can also add just the projects that are selected in the Project Explorer.

Options

Solution

Adds the entire solution, projects, and folder structure to source control.

Selection

Adds only the projects you originally highlighted in the Project Explorer to source control.

Cancel

Cancels the action to add files to source control.


Pull Added Items From Server Dialog Box

Use this dialog box to control when an item is added to your local machine from the source control server. The Items box lists the items that were added to the source control server. You can add these items to your local machine or delay the action.

If you delay the addition, the development environment will remind you that there is a deferred addition to your local machine. You can also choose to do nothing, and keep the added item on the source control server only, with no effect to the local machine.

Options

Items

Displays the new items from the source control server. Click the box next to the items you wish to add to your local machine, based on the button you choose (Add Now, Remind Later, or Do Nothing). A check mark will appear next to selected items.

Add Now

Adds the items selected with a check mark in the Items box. This action pulls the server copy of the added item from source control server to the local machine so that the contents of the solution will match in both places.

You will be reminded later about adding any items you did not select with a check mark in the Items box.

Remind Later

Delays adding the items to the local machine until you are reminded. To select specific items to add to the local machine from the server, click the specific items to add, and then click Add Now.

Pull reminders occur when a project is pulled. Pull actions include Get Latest, Check Out, and Undo Check Out. This is the default setting for reminder dialog boxes. You can change the timing of the dialog boxes by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).

Do Nothing

Leaves all of the items as they are in both places. This means that the source control server's copy of the item is not added to the local machine. You will not be prompted with any more reminders for these items.

Don't show pull reminder dialog boxes

Suppresses any more instances of the Pull Added Items from Server dialog box. You will not be able to add comments or use advanced options until you enable this dialog box again.

You can enable this dialog box again by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Pull Removed Items From Server Dialog Box

Use this dialog box to control when an item is removed on your local machine to match a removal on the source control server. The Items box lists the items that were removed from the source control server. You can remove these items from your local machine or delay the action.

If you delay the removal, the development environment will remind you that there is a deferred removal of items not reflected on your local machine. You can also choose to do nothing, and keep the items on your local machine that were removed on the source control server.

Options

Items

Displays the items removed from the source control server. Click the box next to the items you wish to remove from your local machine, based on the button you choose (Remove Now, Remind Later, or Do Nothing). A check mark will appear next to selected items.

Remove Now

Removes the items selected with check marks in the Items box. This action removes the local copy of the items so that the contents of the solution will match in both places.

You will be reminded later about adding any items you did not select with a check mark in the Items box.

Remind Later

Delays removing the items from the local machine until you are reminded. To select specific items to remove from the local machine, click the items to remove, and then click Remove Now.

Pull reminders occur when a project is pulled. Pull actions include Get Latest, Check Out, and Undo Check Out. This is the default setting for reminder dialog boxes. You can change the timing of the dialog boxes by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).

Do Nothing

Leaves all of the items on the local machine. This means that a local copy of the item, removed on the source control server, is not removed from the local machine. You will not be prompted with any more reminders.

Don't show pull reminder dialog boxes

Suppresses any more instances of the Pull Removed Items from Server dialog box. You will not be able to add comments or use advanced options until you enable this dialog box again.

You can enable this dialog box again by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Push Add To Server Dialog Box

Use this dialog box to control when an item is added to the source control server from your local machine. The Items box lists the items that were added to the local machine. You can add these items to the source control server or delay the action.

If you delay the addition, the development environment will remind you that there are added items that are not pushed to the source control server. You can also choose to do nothing, and keep the added items on your local machine only.

Warning Add your items to the master source control server when the other people sharing that database expect the addition of the item. If other team members are working on the same items as you are, delaying an action to an item may result in conflicting changes later.

Options

Items

Displays the items to add. Click the items you wish to add to the source control server, based on the button you choose (Add Now, Remind Later, or Do Nothing). A check mark will appear next to selected items. These items receive the action of your choice from the buttons (Add Now, Remind Later, or Do Nothing).

Keep Checked Out

Refreshes the source control server with the latest version of the local items that are selected, but keeps the item checked out to you.

Comment

Provides a place to enter comments. You can type up to 4,095 characters.

Add Now

Adds the items selected with check marks in the Items box. This action pushes the local copy of the added item from the local machine to the source control server so that the contents of the solution will match in both places.

You will be reminded later about adding any items you did not select with a check mark in the Items box.

Remind Later

Delays adding the items to the source control server until you are reminded later. To select specific items to add to the server, click the items to add, and then click Add Now.

Push reminders occur when a project is pushed. Push actions are Check In to Source Control and Add to Source Control. This is the default setting for reminder dialog boxes. You can change the timing of the dialog boxes by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).

Do Nothing

Leaves all of the items as they are in both places. This means that the local copy of the item, added locally, is not added to the source control server. You will not be prompted with any more reminders.

Don't show push dialog boxes

Suppresses any more instances of the Push Add to Server dialog box. You can choose whether the development environment automatically delays the action (reminding you later), or never reminds you at all.

You can enable this dialog box again by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).

  • Always Remind — Choose this if you would like the development environment to always defer the action and remind you later. This means that if you add items in the development environment, you will not be immediately prompted, and the environment will automatically delay the addition to source control (reminding you later). You will be reminded to complete the action when you do the following push actions: Check In and Add to Source Control.

  • Always Do Nothing — Choose this if you would like the development environment to do nothing with respect to source control. This means that if you add items in the development environment, you will not be prompted, and the environment will not push the changes to the source control server's database.


Push Remove to Server Dialog Box

Use this dialog box to control when an item is removed from the source control server. The Items box lists the items that were removed from the local machine. You can remove these items from the source control server or delay the action.

If you delay the removal, the development environment will remind you that there are deleted items that are not pushed to the source control server. You can also choose to do nothing, and keep the items on the source control server.

Warning Add your items to the master source control server when the other people sharing that database expect the addition of the item. If other team members are working on the same items as you are, delaying an action to an item may result in conflicting changes later.

Options

Items

Displays the locally deleted items. Click box next to the items you wish to delete on the source control server, based on the button you choose (Add Now, Remind Later, or Do Nothing). A check mark will appear next to selected items.

Remove Now

Deletes the items selected with check marks in the Items box. This action deletes the same items on the source control server that were deleted on your local machine, so that the contents of the solution will match in both places.

You will be reminded later about adding any items you did not select with a check mark in the Items box.

Remind Later

Delays deleting the items from the source control server until you are reminded again. To select specific items to remove from the server, click the items to remove, and then click Remove Now.

Push reminders occur when a project is pushed. Push actions are Check In to Source Control and Add to Source Control. This is the default setting for reminder dialog boxes. You can change the timing of the dialog boxes by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).

Do Nothing

Leaves all of the items as they are in both places. This means that a local copy of the item is not removed in the source control server. You will not be prompted with any more reminders.

Don't show initial push dialog boxes

Suppresses any more instances of the Push Remove to Server dialog box. You can choose whether the development environment automatically delays the action (reminding you later), or never reminds you at all.

You can enable this dialog box again by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).

  • Always Remind — Choose this if you would like the development environment to always defer the action and remind you later. This means that if you delete items in the development environment, you will not be immediately prompted, and the environment will automatically delay the deletion to source control (reminding you later). You will be reminded to complete the action when you do the following push actions: Check In and Add to Source Control.

  • Always Do Nothing — Choose this if you would like the development environment to do nothing with respect to source control. This means that if you delete items in the development environment, you will not be prompted, and the environment will not push the changes to the source control server's database.

Comment

Provides a place to enter comments. If your source control program is Microsoft® Visual SourceSafe™, you can type up to 4,095 characters.

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Push Remove to Server (Incomplete Rename) Dialog Box

Use this dialog box to resolve a situation that is interfering with your action to remove items. The items you deleted locally were not deleted on the source control server. These deleted items match the items you renamed earlier (the renaming was local, and the renaming action to source control was deferred).

Instead of renaming the items on the source control server and then deleting them, you can choose to delete them with the Remove Now option on this dialog box.

The Items box lists the items that you deleted locally. These items were also renamed locally, but the renamed items were not updated on the source control server (the renaming was deferred). The items are listed by their new local names.

If you delay the deletion, the development environment will remind you that there are deleted items that are not pushed to the source control server. You can also choose to do nothing, and keep the items on the source control server.

Warning Add your items to the master source control server when the other people sharing that database expect the addition of the item. If other team members are working on the same items as you are, delaying an action to an item may result in conflicting changes later.

Options

Items

Displays the deleted items from the local machine. Click the box next to the items you wish to delete on the source control server, based on the button you choose (Remove now, Remind later, or Do nothing). A check mark will appear next to selected items.

Remove Now

Removes the items selected with check marks in the Items box from the source control server. This action ignores the deferred renaming of the items on the source control server and deletes them to match your local machine.

You will be reminded later about removing any items you did not select with a check mark in the Items box.

Remind Later

Delays deleting the items from the source control server until you are reminded. To select specific items to remove from the server, click the specific items to remove, and then click Remove Now.

Reminders occur when a project is pushed. Push actions are Check In to Source Control and Add to Source Control. This is the default setting for reminder dialog boxes. You can change the timing of the dialog boxes by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).

Do Nothing

Leaves all of the items as they are in both places. This means that the local copy of the item, removed locally, is not removed in the source control server. You will not be prompted with any more reminders.

Don't show initial push dialog boxes

Suppresses any more instances of the Push Remove to Server (Incomplete Rename) dialog box. You can choose whether the development environment automatically delays the action (reminding you later), or never reminds you at all.

You can enable this dialog box again by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).

  • Always Remind — Choose this if you would like the development environment to always defer the action and remind you later. This means that if you delete items in the development environment, you will not be immediately prompted, and the environment will automatically delay the deletion to source control (reminding you later). You will be reminded to complete the action when you do the following push actions: Check In and Add to Source Control.

  • Always Do Nothing — Choose this if you would like the development environment to do nothing with respect to source control. This means that if you delete items in the development environment, you will not be prompted, and the environment will not push the changes to the source control server's database.

Comment

Provides a place to enter comments. If your source control program is Microsoft® Visual SourceSafe™, you can type up to 4,095 characters.

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Push Rename to Server Dialog Box

Use this dialog box to control when an item is renamed on the source control server. The Items box lists the items that were renamed on the local machine. You can rename these items on the source control server or delay the action.

If you delay the renaming, the development environment will remind you that there are renamed items that are not pushed to the source control server. You can also choose to do nothing, and keep the items on the source control server with their old names.

Warning Add your items to the master source control server when the other people sharing that database expect the addition of the item. If other team members are working on the same items as you are, delaying an action to an item may result in conflicting changes later.

Options

Items

Displays the renamed items on the local machine. Click the items you wish to rename on the source control server, based on the button you choose (Add Now, Remind Later, or Do Nothing). A check mark will appear next to selected items.

Rename Now

Renames on the source control server the items selected with check marks in the Items box. This action pushes the new name of the item from the local machine to the source control server so that the contents of the solution will match in both places.

You will be reminded later about renaming any items you did not select with a check mark in the Items box.

Remind Later

Delays renaming the items from the source control server until you are reminded again. To select specific items to rename on the server, select the box of the specific items to rename, and then click Rename Now.

Reminders occur when a project is pushed. Push actions are Check In to Source Control and Add to Source Control. This is the default setting for reminder dialog boxes. You can change the timing of the dialog boxes by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).

Do Nothing

Leaves all of the items as they are in both places. This means that the local copy of the item, renamed locally, is not renamed on the source control server. You will not be prompted with any more reminders.

Don't show push reminder dialog boxes

Suppresses any more instances of the Push Rename to Server dialog box. You can choose whether the development environment automatically delays the action (reminding you later), or never reminds you at all.

You can enable this dialog box again by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).

  • Always Remind — Choose this if you would like the development environment to always defer the action and remind you later. This means that if you rename items in the development environment, you will not be immediately prompted, and the environment will automatically delay the rename request to source control (reminding you later). You will be reminded to complete the action when you do the following push actions: Check In and Add to Source Control.

  • Always Do Nothing — Choose this if you would like the development environment to do nothing with respect to source control. This means that if you rename items in the development environment, you will not be prompted, and the environment will not push the changes to the source control server's database.


Reminder To Push Add To Server Dialog Box

Use this dialog box to control when an item is added to the source control from your local machine. The Items box lists the items that were added to the local machine. You can add these items to the source control server or continue to delay the action.

If you delay the addition, the development environment will continue to remind you that there are added items that are not pushed to the source control server. You can also choose to do nothing, and keep the added items on your local machine only.

Warning Add your items to the master source control server when the other people sharing that database expect the addition of the item. If other team members are working on the same items as you are, delaying an action to an item may result in conflicting changes later.

Options

Items

Displays the added items. Click the box next to the items you wish to add to the source control server, based on the button you choose (Add Now, Remind Later, or Do Nothing). A check mark will appear next to selected items.

Add Now

Adds the items selected with check marks in the Items box. This action pushes the local copy of the added item from the local machine to the source control server so that the contents of the solution will match in both places.

You will be reminded later about adding any items you did not select with a check mark in the Items box.

Remind Later

Delays adding the items to the source control server until you are reminded again. To select specific items to add to the server, click the specific items to add, and then click Add Now.

Push reminders occur when a project is pushed. Push actions are Check In to Source Control and Add to Source Control. This is the default setting for reminder dialog boxes. You can change the timing of the dialog boxes by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).

Do Nothing

Leaves all of the items as they are in both places. This means that the local copy of the item, added locally, is not added to the source control server. You will not be prompted with any more reminders.

Don't show push reminder dialog boxes

Suppresses any more instances of the Reminder to Push Add to Server dialog box. You will not be able to add comments or use advanced options until you enable this dialog box again.

You can enable this dialog box again by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).

Keep Checked Out

Refreshes the source control server with the latest version of the local items that are selected, but keeps the items checked out to you.

Comment

Provides a place to enter comments. You can type up to 4,095 characters.


Reminder to Push Remove to Server Dialog Box

Use this dialog box to control when an item is removed from the source control server. The Items box lists the items that were removed from the local machine. You can remove these items from the source control server or continue to delay the action.

If you delay the removal, the development environment will continue to remind you that there are deleted items that are not pushed to the source control server. You can also choose to do nothing, and keep the items on the source control server.

Warning Add your items to the master source control server when the other people sharing that database expect the addition of the item. If other team members are working on the same items as you are, delaying an action to an item may result in conflicting changes later.

Options

Items

Displays the locally deleted items. Click the box next to the items you wish to delete on the source control server, based on the button you choose (Add Now, Remind Later, or Do Nothing). A check mark will appear next to selected items.

Remove Now

Deletes the items selected with check marks in the Items box. This action deletes the same items on the source control server that were deleted on your local machine, so that the contents of the solution will match in both places.

You will be reminded later about adding any items you did not select with a check mark in the Items box.

Remind Later

Delays deleting the items from the source control server until you are reminded again. To select specific items to remove from the server, click the specific items to remove, and then click Remove Now.

Push reminders occur when a project is pushed. Push actions are Check In to Source Control and Add to Source Control. This is the default setting for reminder dialog boxes. You can change the timing of the dialog boxes by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).

Do Nothing

Leaves all of the items as they are in both places. This means that the local copy of the item, removed locally, is not removed in the source control server. You will not be prompted with any more reminders.

Don't show push reminder dialog boxes

Suppresses any more instances of the Reminder to Push Remove to Server dialog box. You will not be able to add comments or use advanced options until you enable this dialog box again.

You can enable this dialog box again by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).

Comment

Provides a place to enter comments. If your source control program is Microsoft® Visual SourceSafe™, you can type up to 4,095 characters.

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Reminder to Push Rename to Server Dialog Box

Use this dialog box to control when an item is renamed on the source control server. The Items box lists the items that were renamed on the local machine. You can rename these items on the source control server or continue to delay the action.

If you delay the renaming, the development environment will continue to remind you that there are renamed items that are not pushed to the source control server. You can also choose to do nothing, and keep the items on the source control server with their old names.

Warning Add your items to the master source control server when the other people sharing that database expect the addition of the item. If other team members are working on the same items as you are, delaying an action to an item may result in conflicting changes later.

Options

Items

Displays the renamed items on the local machine. Click the box next to the items you wish to rename on the source control server, based on the button you choose (Add Now, Remind Later, or Do Nothing). A check mark will appear next to selected items.

Rename Now

Renames on the source control server the items selected with check marks in the Items box. This action pushes the new name of the item from the local machine to the source control server so that the contents of the solution will match in both places.

You will be reminded later about renaming any items you did not select with a check mark in the Items box.

Remind Later

Delays renaming the items from the source control server until you are reminded again. To select specific items to rename on the server, click the specific items to rename, and then click Rename Now.

Reminders occur when a project is pushed. Push actions are Check In to Source Control and Add to Source Control. This is the default setting for reminder dialog boxes. You can change the timing of the dialog boxes by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).

Do Nothing

Leaves all of the items as they are in both places. This means that a local copy of the item, renamed locally, is not renamed on the source control server. You will not be prompted with any more reminders.

Don't show initial push dialog boxes

Suppresses any more instances of the Reminder to Push Rename to Server dialog box. You will not be able to add comments or use advanced options until you enable this dialog box again.

You can enable this dialog box again by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).


Remove Items From Source Control Dialog Box

Use this dialog box to delete an item from source control through the Microsoft development environment. Items selected with a check mark will be deleted from the source control server's database. For best results, remove items through the development environment instead of through the source control program. This allows the development environment to keep a record of the items in your project.

You cannot remove entire projects or entire solutions from the source control database with this dialog box. For details on removing a source control project in the source control program, see your source control documentation.

If you lost a connection to your project or solution in source control because the project or solution was branched, you can reconnect using the Change/Set Connection dialog box.

Options

Items

Displays a list of the items based on your current selection in the Project Explorer (in the development environment). Select the box next to the items you wish to remove from source control and a check mark will appear next to the item. You can click Check All to select all of the items at once.

This box displays the first level of folders and contents to which you can apply these operations. To see additional items contained within subfolders, click Recurse. Items contained within a subfolder are not removed from source control unless they are displayed individually in the Items box and selected with a check mark.

Check All

Selects with a check mark all of the items visible in the Items box. To see additional subfolders and levels of items, click Recurse. Only items that are visible in the Items box and are shown with a check mark are removed from source control.

Recurse

Forces items to be displayed in subfolders in the Items box. You can then select these items for source control actions.

By default, the Items box displays only the first level of items contained in the Project Explorer for the development environment. Clicking Recurse displays all of the subfolders and all of their items for any remaining levels of depth in the directory tree, as shown in the Project Explorer. You can then select additional items for actions in source control.

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Rename Item in Source Control Dialog Box

Use this dialog box to rename an item in the source control database. Do not use this dialog box to rename your item in the local project — use the Rename command on the File menu. This dialog box renames items only within the source control server's database, and these changes are not reflected in the local machine.

Options

Current item name

Displays the current name of the item.

New item name

Sends the rename request to the source control system to be evaluated. Your source control server will supply you with any possible results. This new name changes only in the source control server's database and is not reflected on your local machine. Name restrictions and limitations are defined by your source code control program.


Save of Read-Only File Dialog Box

Use this dialog box to save a file marked as read-only. Sometimes a file is marked read-only if you copy it from a CD to a disk.

Options

Overwrite

Overwrites the read-only version of the file with the current version.

Save As

Saves the file with a different name than the read-only copy.

Don’t Save

Cancels the save operation on just this file. Any other files involved are not affected.

Cancel

Cancels the entire save operation for all files.


Set Source Control Connection Dialog Box

Use this dialog box to change the reference location of the source control database/server that you are using. This connection may be interrupted from a project or solution branch on the source control server or from network troubles. You can point the Microsoft development environment to the new location with the Change/Set Connection button.

You can also use this dialog box to tell the development environment when you are working offline (not connected to the source control database/server). This can be intentional, such as when you are working remotely on a laptop, or accidental, as when a network connection breaks.

Options

Change Selected Projects to

  • Work Offline — Acknowledges a disconnection from the source control server. Click this if your connection to the source control server is lost or you wish to work remotely. You can change back to working online by using the Set Connection menu command on the Source Control menu item.

  • Work Online — Restores your connection with the source control database/server.

Change/Set Connection

Displays the Login or Browse dialog box supplied by your source control program.

Apply changes to other projects with similar connections

Applies your changes to projects that share the same source control property types. There are two types of projects: web projects and everything else. Web projects are projects similar to Visual InterDev™ projects. Everything else can be Visual J++™, database, utility, distribution unit and other kinds of projects.

If you are changing your source control connection to work online or offline, then checking this box will apply the changes to the similar types of projects, Web or otherwise.

If you are changing your source control settings, project location, database, or other process by clicking Set/Change Connection, then checking this box applies these changes to a much more specific set of projects. This will include projects that were added to source control together at once, usually through the feature that adds the whole solution at once (in the Initial Add to Source Control dialog box).


Source Control (Environment - Options Dialog Box)

Use this dialog box to customize your interface with source control. You can set source control dialog boxes to appear, appear only in specific cases, or disappear. You can set up default behaviors to fit your work style. For example, you can set the development environment to automatically update all of the items by getting the latest version of all of the items associated with a solution when you open that solution.

You can change some options in the dialog boxes themselves. You can enable dialog boxes again by changing options here.

Options

Get everything when opening a solution

Sets the development environment to Get all items associated with a solution every time you open that solution. You can disable the Get Latest Version dialog box by selecting the Don't show this dialog box again check box on the dialog box itself.

Check in everything when closing the solution

Sets the development environment to check in all items associated with a solution every time you close that solution. You can disable the Check In Items dialog box by either selecting the Don't show this dialog box again check box on the dialog box. You can enable this dialog box again by selecting the Show detail dialog boxes (Check In) check box on this Options page.

Perform background status updates

Sets the development environment to retrieve source control information from the master database when items are updated. This option is only available for other source control programs; it is not available in Visual SourceSafe.

Add new projects to source control

Sets the development environment to automatically add new projects or items to source control. For items only, the Add to Source Control dialog box can be disabled by either selecting the Don't show this dialog box again button on the dialog box, or by selecting the After item add, remove or rename check box on this page.

When checked in items are edited

Sets the preferred default behavior of the development environment when you are editing an item that is not checked out from source control (and is therefore read-only).

  • Check Out — Checks out all items every time you start to edit an item. The development environment beeps as the item is checked out of source control. You may lose a keystroke while this action is performed. The editor may change to adapt to the new status of the item.

  • Prompt — Causes the Check Out Items dialog box to appear every time you start to edit an item. With the dialog box enabled, you can set advanced options and add comments.

  • Do Nothing — Disables all source control dialog boxes. The development environment does nothing when you edit an item that is not checked out. Your changes will only be on your local machine.

After item add, remove or rename

Sets the preferred default behavior of the development environment when you are adding an item, removing an item, or renaming an item locally. Typically, the development environment will prompt you to reflect these changes in the source control database. You can defer these changes with reminders, or do nothing.

You can set the default to:

  • Prompt — Shows the appropriate dialog box for that action (Add to Source Control, Remove from Source Control, or Rename).

  • Remind Later — Defers the action from the source control database, and triggers reminder dialog boxes about the deferred items. This keeps all of the added items, removed items, and renamed items local (changes are not reflected in the source control database).

  • Do Nothing — Disables all dialog boxes and reminders. Sets the default behavior to no dialog boxes when these actions occur. These changes will remain local and are not reflected in the source control database.

Show pull reminders

Enables pull reminder dialog boxes according to the frequency setting you choose.

Pull actions are changes retrieved from the source control server to the local machine. Pull actions include Get Latest, Check Out, and Undo Check Out. Pull reminder dialog boxes prompt you to synchronize the source control server and your local machine so that the same versions of the items exist in both places. Reminder dialog boxes can perform the action, delay the action until later, or skip the action entirely.

  • On Every Pull — Shows the reminder dialog boxes every time you perform a pull action (Get Latest, Check Out, or Undo Check Out) on any item in the Project Explorer.

  • On Project Pull — Shows the reminder dialog boxes when you perform a pull action (Get Latest, Check Out, or Undo Check Out) only on a project in the Project Explorer. This is the default setting.

  • Never — Disables the pull reminder dialog boxes.

Show push reminders

Enables push reminder dialog boxes according to the frequency setting you choose.

Push actions are changes sent to the source control server from the local machine. Push actions include Check In and Add to Source Control. Push reminder dialog boxes prompt you to synchronize the source control server and the local machine so that the same versions of the items exist in both places. Reminder dialog boxes can perform the action, delay the action until later, or skip the action entirely.

  • On Every Push — Shows the reminder dialog boxes every time you perform a push action (Check In or Add to Source Control) on any item in the Project Explorer.

  • On Project Push — Shows the reminder dialog boxes when you perform a push action (Check In or Add to Source Control) only on a project in the Project Explorer. This is the default setting.

  • Never — Disables the push reminder dialog boxes.

Detail dialog boxes

Enables or disables the source control integration dialog boxes. Select the check box appropriate to show the detail dialog box during the source control action. There are dialog boxes for: Check Out, Check In, Get Latest Version, Undo Check Out, and Add to Source Control.

For example, when you check an item into source control, you will see the Check In Items dialog box. On this dialog box you can select the Don't show this dialog box again check box to disable the Check In Items dialog box. When you next check in an item, you will not be prompted by the dialog box you disabled. While this technique is useful for repetitive actions, you cannot fill in comments or click any advanced source control options (where they are available) when the dialog boxes are not enabled. Select the check box for the dialog box here to enable it.

Include only selected items

Controls the amount of information that appears in the Items list of the source control dialog boxes. The default is that only selected items (or all of the items in a selected solution) will appear in the Items box. You can expand that list by selecting the Recurse check box on the dialog box in question, or change this option.

Login

Provides a place for you to enter your name here for logging into the source control database server. If supported by your source control provider, this name will be filled in automatically in the Login dialog box to reach your source control server.

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Specify Working Directory Dialog Box

Use this dialog box to fix a situation in which a single item has been added to a directory level above the project directory. If this is not fixed, the source control copy of the project directory may inherit additional items and duplicate them in unexpected places.

Options

Project

Displays the current directory to which the specific project was added.

Working Directory

Displays a suggested working directory. To change the working directory entry, type the desired path or click Browse to select it.

If you change the suggested working directory, you should choose the new path carefully. The definition of the working directory and the best choice for its location depend on the source control provider you are using.

For example, if you are using Visual SourceSafe, the root working directory for a source control project should be at or above the level of all of the items you intend to add to the source control project. Suppose your project contains include or header files that do not reside within or below the folder containing the project file. The related source control project should have a working directory that contains all of these items within its nested subdirectories.


Undo Check Out Dialog Box

Use this dialog box to undo a check out of a solution, project, or individual item from source control. Items selected with a check mark in the Items box are returned to the state they were in before you checked them out.

Undoing a check out returns the item to read-only status in source control. No changes are saved to the source control database. The item returns to its condition and version before you checked it out.

Options

Items

Displays a list of the items based on your current selection in the Project Explorer (in the development environment). Select the box next to the items you wish to undo. A check mark will appear next to the item. You can click Check All to select all of the items at once.

This box displays the first level of folders and contents to which you can apply these operations. To see additional items contained within subfolders, click Recurse. Items contained within a subfolder are not undone for their check out unless they are displayed individually in the Items box and selected with a check mark.

Check All

Selects with a check mark all of the items visible in the Items box. To see additional subfolders and levels of items, click Recurse. Only items that are visible in the Items box and are shown with a check mark are affected by your action in this dialog box.

Recurse

Forces items to be displayed in subfolders in the Items box. You can then select these items for source control actions.

By default, the Items box displays only the first level of items contained in the Project Explorer for the development environment. Clicking Recurse displays all of the subfolders and all of their items for any remaining levels of depth in the directory tree, as shown in the Project Explorer. You can then select additional items for actions in source control.

Don't show this dialog box again

Suppresses any more instances of the Undo Check Out dialog box. Undo Check Out becomes a direct command on the environment menus. You will not be able to add comments or use advanced options until you enable this dialog box again.

You can enable this dialog box again by changing the options listed in the Source Control page (on the Tools menu, click Options, and then expand the Environment node and click the Source Control node).

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Source Code Control Error Messages

<Name> This file has changed on disk. Please close the editor and reopen it.

An error has occurred accessing source control

Another Microsoft Development Environment project already exists

Caution: You are trying to add to source control items that are already there

Do you want to put this newly created project under source control?

Error accessing source control system. Check installation

Error accessing source control system. Check network status

If you rename this folder, the files and folders within it will not be seen

No items are currently valid for this operation

No projects are under source control

No source control system is installed and/or loaded

Please upgrade to SourceSafe 5.0 or newer

Solution could not be put under source control

Some project files need updated source control settings

Someone has apparently added items with the same names as renamed items

Source code control project contains files for a different product

Source code control project contains no files

Source control project could not be initialized

The checkout for save failed

The directory you chose already contains some of the solution files

The new name you are attempting to give this item is the same as the name

The selected source control project contains a similar project

The solution could not be put under source control.

This solution may have been forked…

The source control project you changed connection to contains no project or solution files. Choose another.

The source control project you changed connection to contains no project or solution files that match the projects you are acting on.

The source control project you selected contains no project or solution files. Please select a different project.

The source control rename failed

The source control system does not support the command

There was an error trying to make the file <name> writeable.

Warning: Someone appears to have added items to the source control project

Warning: You appear to have added items to your project with the same names

You already have local copies of some of the solution or project files

You already have local copies of all of the solution or project files

You are trying to rename an item to the name of an item that already exists

You must only enter a filename

Your source code control provider does not provide all the capabilities required


<Name> This file has changed on disk. Please close the editor and reopen it.

An operation caused the file to change on the disk. The editor that currently has the file open does not support reloading files. To insure that no changes are lost, close the editor and re-open the modified file.


An error has occurred accessing source control

The source control provider reported that it is unable to access the source control database.

Check network connections and contact the system administrator for the database server.


Another Microsoft Development Environment project already exists

To avoid clashes between multiple projects, you can store only one project in a location.


Caution: You are trying to add to source control items that are already there

Source control already contains an item with the same item name but differing contents.

Use the explorer to view the item already in source control.


Do you want to put this newly created project under source control?

Use this message to confirm whether you want to include the project you are creating in source control. If you choose yes, you can also choose whether you want to add the whole solution to source control.


Error accessing source control system. Check installation

The source control system is not accessible.

Try the following:

  • Check the source control server to ensure it is accessible, then contact your source control administrator.

  • Reinstall source control.


Error accessing source control system. Check network status

The source control system is not accessible.

Check the network to ensure you can access the source control, then contact your network or source control administrator.


If you rename this folder, the files and folders within it will not be seen

If you choose yes to this message, the local copies of the files and folders within the folder you are renaming will be decoupled from their server counterparts, and will no longer be connected to the renamed folder in source control. If you rename a local folder, you should use the source control explorer to rename the corresponding folder on the source control server.


No items are currently valid for this operation

The command you selected was enabled on the menu, but source control has determined that the command does not apply to any of the selected items.


No projects are under source control

The command you chose does not apply because no projects are yet in source control.


No source control system is installed and/or loaded

You chose a source control command, but source control is either not installed or not loaded on this computer.


Please upgrade to SourceSafe 5.0 or newer

Your system is using Visual SourceSafe version 4.x or earlier.

Upgrade to a newer version of Visual SourceSafe to use source control in the Microsoft development environment.


Solution could not be put under source control

The system has encountered a problem that is not clearly related to the source control installation or to network status.

Contact your source control system administrator.


Some project files need updated source control settings

The Microsoft development environment has identified inconsistencies between the source control settings found in your project or solution files and those stored in your local cache. The system attempted to resolve the problems by checking out and fixing the project and solution files but was unable to do so. This may indicate that someone else exclusively checked out the project and solution, or it may indicate another problem with the source control system.

If you have not recently branched or forked your project, the development environment will be able to resolve the situation and you do not need to do any further action.


Someone has apparently added items with the same names as renamed items

The Microsoft development environment found that two files exist with the same name and different contents. One of these files is your local file, and the other was added to source control while you renamed your local file.

Try renaming your local file.


Source code control project contains files for a different product

You may have files in source control from an older version of Visual Studio.

Try getting your files from source control in Visual Studio 5.0, then convert the files to Visual Studio 6.0. Once you do this, you can add the new Visual Studio 6.0 files to source control.


Source code control project contains no files.

No files were found in source control. Browse to locate the appropriate files.


Source control project could not be initialized

The source control system is not accessible.

Check the network to ensure you can access the source control, then contact your network or source control administrator.


The checkout for save failed

The source control system failed to check out the file.

Check your network server and the file permissions on the file you are trying to save.


The directory you chose already contains some of the solution files

During the enlistment process, the Microsoft development environment found some of the same files locally as on the source control server.

Try the following:

  • Choose a new directory to enlist in.

  • Remove the old files you don’t want from the current enlistment directory.


The new name you are attempting to give this item is the same as the name

The Microsoft development environment found that the new item you are renaming matches an older item that was deleted locally (but is still waiting to be deleted on the server).

Click Yes to finish deleting the older item on the server. Click No to cancel the rename.


The selected source control project contains a similar project

The Microsoft development environment found the local project is disconnected from its source control project.

Use the Change Connection command to locate your source control project again.


The solution could not be put under source control.

The source control system has encountered a problem that is internal.

Contact your source control system administrator.


The source control project you changed connection to contains no project or solution files. Choose another.

The Microsoft development environment found no project or solution files in the source control location to which you were trying to change a connection. Check the location of the project or solution in source control and try a different source control project.


The source control project you changed connection to contains no project or solution files that match the projects you are acting on.

The Microsoft development environment found no significant matches of the same files between your project and the source control project you are trying to change a connection to. To change the connection, you must point the development environment to the unified root, or the location you selected when you added the source control project initially.

A network failure could cause this error. Contact your source control administrator for more information.


The source control project you selected contains no project or solution files. Please select a different project.

The Microsoft development environment found no project or solution files in the source control location in which you are trying to enlist. Check the location of the project or solution in source control and try a different source control project.


The source control rename failed

The source control system denied your rename request.

Try the following:

  • Check the file status (cannot rename a file while it is checked out).

  • Use a different name.

  • Check with your source control administrator for further details.


The source control system does not support the command

The source control system does not support this command.

Check your source control system documentation for ways to complete your task.


There was an error trying to make the file <name> writeable.

The Microsoft development environment tried to overwrite a read-only file. Check your file to see if it is stored on a CD, a read-only floppy disk, or a restricted network drive.


This solution may have been forked

The Microsoft development environment found that the source control settings for this project do not match the source control system project settings. Your solution is probably forked.

Contact your source code control administrator to correct the fork for the project.


Warning: Someone appears to have added items to the source control project

The Microsoft development environment found that a new item in source control matches an older item that is local. The names of the files are the same, but the contents are different.

Try renaming your local file.


Warning: You appear to have added items to your project with the same names

The Microsoft development environment found that the item you are adding locally has the same name as an older item on the source control server. The names of the files are the same, but the contents are different.

Try renaming your local file.


You already have local copies of all of the solution or project files

During the enlistment process, the Microsoft development environment found all the project or solution files already present on your local computer. The enlistment will fail.

Use the Get Latest Version command to update the files. Clicking SCC in the Open Project dialog box enlists your project in source control. After enlisting, click Open to open your project.


You already have local copies of some of the solution or project files

During the enlistment process, the Microsoft development environment found some project or solution files already present on your local computer. The enlistment will finish, but some of these files will be out of date.

Use the Get Latest Version command to update the files. Clicking SCC in the Open Project dialog box enlists your project in source control. After enlisting, click Open to open your project.


You are trying to rename an item to the name of an item that already exists

The rename action is cancelled because this name is in use.

Try using another name.


You must only enter a filename

The Microsoft development environment can only accept file names for renaming files — not path, folder, or directory names.


Your source code control provider does not provide all the capabilities required

Your source control system version may be out of date or unable to give you all the features expected in the Microsoft development environment.

Contact your source control system administrator for details.


Topic Not Found

No matching topic was found. Some possible reasons and remedies are as follows:

  • The file (.chm) that contains the destination topic is not in the expected location.

    Remedy: Rerun the MSDN Library Setup.

  • The file (.chm) that contains the current topic or destination topic is out-of-date and the link is no longer valid.

    Remedy: Install the latest version of the MSDN Library.

  • The MSDN Library CD is not in the CD-ROM drive.

    Remedy: Insert the MSDN Library CD into the CD-ROM drive.